/*
 * (C) Copyright ParaSoft Corporation 2022.  All rights reserved.
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft
 * The copyright notice above does not evidence any
 * actual or intended publication of such source code.
 */

#ifndef _INTERFACE_INFO_ITERATOR_H
#define _INTERFACE_INFO_ITERATOR_H

#include "../InterfaceInfo.h"

#include <winsock2.h>
#include <iphlpapi.h>

class InterfaceInfoIterator
{
public:
    InterfaceInfoIterator();

    ~InterfaceInfoIterator();

    bool hasNext();

    InterfaceInfo* next();

private:
    unsigned char* _customMac;
    PIP_ADAPTER_ADDRESSES _pAddressIt;
    
    void fillInterfaceInfo(InterfaceInfo* result, PIP_ADAPTER_ADDRESSES pAddress);

    // Degenerate copy and assignment
    InterfaceInfoIterator(const InterfaceInfoIterator&);
    InterfaceInfoIterator& operator=(const InterfaceInfoIterator&);
};

#endif
